diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/attribute-helper.h ns-3.31/src/core/model/attribute-helper.h
--- ns-3.30.1/src/core/model/attribute-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/attribute-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -34,7 +34,7 @@
 namespace ns3 {
 
 /**
- * \ingroup attribute
+ * \ingroup attributes
  * \defgroup attributehelper Attribute Helper
  *
  * All these macros can be used to generate automatically the code
@@ -87,9 +87,9 @@
  *
  * \tparam T    \explicit The specific AttributeValue type used to represent
  *              the Attribute.
- * \tparam BASE \explicit The AttributeChecker type corresponding to \p T.
+ * \tparam BASE \explicit The AttributeChecker type corresponding to \pname{T}.
  * \param [in] name  The name of the AttributeValue type, essentially the
- *              string form of \p T.
+ *              string form of \pname{T}.
  * \param [in] underlying Underlying type name.
  * \return Ptr to AttributeChecker.
  */
@@ -103,22 +103,28 @@
    */
   struct SimpleAttributeChecker : public BASE
   {
-    virtual bool Check (const AttributeValue &value) const {
+    virtual bool Check (const AttributeValue &value) const
+    {
       return dynamic_cast<const T *> (&value) != 0;
     }
-    virtual std::string GetValueTypeName (void) const {
+    virtual std::string GetValueTypeName (void) const
+    {
       return m_type;
     }
-    virtual bool HasUnderlyingTypeInformation (void) const {
+    virtual bool HasUnderlyingTypeInformation (void) const
+    {
       return true;
     }
-    virtual std::string GetUnderlyingTypeInformation (void) const {
+    virtual std::string GetUnderlyingTypeInformation (void) const
+    {
       return m_underlying;
     }
-    virtual Ptr<AttributeValue> Create (void) const {
+    virtual Ptr<AttributeValue> Create (void) const
+    {
       return ns3::Create<T> ();
     }
-    virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const {
+    virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const
+    {
       const T *src = dynamic_cast<const T *> (&source);
       T *dst = dynamic_cast<T *> (&destination);
       if (src == 0 || dst == 0)
@@ -142,11 +148,11 @@
  * \ingroup attributehelper
  *
  * Define the attribute accessor functions \c MakeTypeAccessor
- * for class \p type.
+ * for class \pname{type}.
  *
  * \param [in] type The name of the class
  *
- * This macro defines and generates the code for the implementation 
+ * This macro defines and generates the code for the implementation
  * of the \c MakeTypeAccessor template functions. This macro is typically
  * invoked in a class header to allow users of this class to view and
  * use the template functions defined here. This macro is implemented
@@ -167,8 +173,8 @@
 /**
  * \ingroup attributehelper
  *
- * Declare the attribute value class \p nameValue
- * for underlying class \p type.
+ * Declare the attribute value class \pname{nameValue}
+ * for underlying class \pname{type}.
  *
  * \param [in] type The underlying type name token
  * \param [in] name The token to use in defining the accessor name.
@@ -190,16 +196,16 @@
     void Set (const type &value);                                       \
     type Get (void) const;                                              \
     template <typename T>                                               \
-      bool GetAccessor (T &value) const {                               \
+    bool GetAccessor (T & value) const {                                \
       value = T (m_value);                                              \
       return true;                                                      \
     }                                                                   \
     virtual Ptr<AttributeValue> Copy (void) const;                      \
     virtual std::string                                                 \
-      SerializeToString (Ptr<const AttributeChecker> checker) const;    \
+    SerializeToString (Ptr<const AttributeChecker> checker) const;      \
     virtual bool                                                        \
-      DeserializeFromString (std::string value,                         \
-                             Ptr<const AttributeChecker> checker);      \
+    DeserializeFromString (std::string value,                           \
+                           Ptr<const AttributeChecker> checker);        \
   private:                                                              \
     type m_value;                                                       \
   }
@@ -208,8 +214,8 @@
 /**
  * \ingroup attributehelper
  *
- * Declare the attribute value class \p nameValue
- * for the class \p name
+ * Declare the attribute value class \pname{nameValue}
+ * for the class \pname{name}
  *
  * \param [in] name The name of the class.
  *
@@ -223,7 +229,7 @@
 /**
  * \ingroup attributehelper
  *
- * Define the conversion operators class \p type and
+ * Define the conversion operators class \pname{type} and
  * Attribute instances.
  *
  * \param [in] type The name of the class
@@ -240,15 +246,15 @@
 /**
  * \ingroup attributehelper
  *
- * Declare the AttributeChecker class \p typeChecker
- * and the \c MaketypeChecker function for class \p type.
+ * Declare the AttributeChecker class \pname{typeChecker}
+ * and the \c MaketypeChecker function for class \pname{type}.
  *
  * \param [in] type The name of the class
  *
- * This macro declares the \p typeChecker class and the associated
+ * This macro declares the \pname{typeChecker} class and the associated
  * \c MaketypeChecker function.
  *
- * (Note that the \p typeChecker class needs no implementation
+ * (Note that the \pname{typeChecker} class needs no implementation
  * since it just inherits all its implementation from AttributeChecker.)
  *
  * Typically invoked in the class header file.
@@ -262,15 +268,15 @@
  * \ingroup attributehelper
  *
  * Define the class methods belonging to
- * the attribute value class \p nameValue 
- * of the underlying class \p type.
+ * the attribute value class \pname{nameValue}
+ * of the underlying class \pname{type}.
  *
  * \param [in] type The underlying type name
  * \param [in] name The token to use in defining the accessor name.
  *
- * This macro implements the \p typeValue class methods
- * (including the \p typeValue::SerializeToString
- * and \p typeValue::DeserializeFromString methods).
+ * This macro implements the \pname{typeValue} class methods
+ * (including the \pname{typeValue}%::%SerializeToString
+ * and \pname{typeValue}%::%DeserializeFromString methods).
  *
  * Typically invoked in the source file
  */
@@ -291,32 +297,32 @@
   }                                                                     \
   std::string name ## Value::SerializeToString                          \
     (Ptr<const AttributeChecker> checker) const {                       \
-      std::ostringstream oss;                                           \
-      oss << m_value;                                                   \
-      return oss.str ();                                                \
+    std::ostringstream oss;                                             \
+    oss << m_value;                                                     \
+    return oss.str ();                                                  \
   }                                                                     \
   bool name ## Value::DeserializeFromString                             \
     (std::string value, Ptr<const AttributeChecker> checker) {          \
-      std::istringstream iss;                                           \
-      iss.str (value);                                                  \
-      iss >> m_value;                                                   \
-      NS_ABORT_MSG_UNLESS (iss.eof (),                                  \
-                           "Attribute value " << "\"" << value << "\""  \
-                           << " is not properly formatted");            \
-      return !iss.bad () && !iss.fail ();                               \
+    std::istringstream iss;                                             \
+    iss.str (value);                                                    \
+    iss >> m_value;                                                     \
+    NS_ABORT_MSG_UNLESS (iss.eof (),                                    \
+                         "Attribute value " << "\"" << value << "\"" << \
+                         " is not properly formatted");                 \
+    return !iss.bad () && !iss.fail ();                                 \
   }
 
 /**
  * \ingroup attributehelper
  *
  * Define the class methods belonging to
- * attribute value class \p typeValue for class \p type.
+ * attribute value class \pname{typeValue} for class \pname{type}.
  *
  * \param [in] type The name of the class.
  *
- * This macro implements the \p typeValue class methods
- * (including the \p typeValue::SerializeToString
- * and \p typeValue::DeserializeFromString methods).
+ * This macro implements the \pname{typeValue} class methods
+ * (including the \pname{typeValue}%::%SerializeToString
+ * and \pname{typeValue}%::%DeserializeFromString methods).
  *
  * Typically invoked in the source file.
  */
@@ -327,7 +333,7 @@
 /**
  * \ingroup attributehelper
  *
- * Define the \c MaketypeChecker function for class \p type.
+ * Define the \c MaketypeChecker function for class \pname{type}.
  *
  * \param [in] type The name of the class
  *
@@ -338,45 +344,45 @@
 #define ATTRIBUTE_CHECKER_IMPLEMENT(type)                               \
   Ptr<const AttributeChecker> Make ## type ## Checker (void) {          \
     return MakeSimpleAttributeChecker<type ## Value,type ## Checker>    \
-      (# type "Value", # type);                                         \
+             (# type "Value", # type);                                  \
   }                                                                     \
 
 /**
  * \ingroup attributehelper
  *
- * Define the \c MaketypeChecker function for class \p type.
+ * Define the \c MaketypeChecker function for class \pname{type}.
  *
  * \param [in] type The name of the class.
  * \param [in] name The string name of the underlying type.
  *
  * This macro implements the \c MaketypeChecker function
- * for class \p type.
+ * for class \pname{type}.
  *
  * Typically invoked in the source file..
  */
 #define ATTRIBUTE_CHECKER_IMPLEMENT_WITH_NAME(type,name)                \
   Ptr<const AttributeChecker> Make ## type ## Checker (void) {          \
     return MakeSimpleAttributeChecker<type ## Value,type ## Checker>    \
-      (# type "Value", name);                                           \
+             (# type "Value", name);                                    \
   }                                                                     \
 
 /**
  * \ingroup attributehelper
  *
- * Declare the attribute value, accessor and checkers for class \p type
+ * Declare the attribute value, accessor and checkers for class \pname{type}
  *
  * \param [in] type The name of the class
  *
  * This macro declares:
  *
- *   - The attribute value class \p typeValue,
+ *   - The attribute value class \pname{typeValue},
  *
  *   - The attribute accessor functions \c MaketypeAccessor,
  *
- *   - The AttributeChecker class \p typeChecker
+ *   - The AttributeChecker class \pname{typeChecker},
  *     and the \c MaketypeChecker function,
  *
- * for class \p type.
+ * for class \pname{type}.
  *
  * This macro should be invoked outside of the class
  * declaration in its public header.
@@ -389,17 +395,17 @@
 /**
  * \ingroup attributehelper
  *
- * Define the attribute value, accessor and checkers for class \p type
+ * Define the attribute value, accessor and checkers for class \pname{type}
  *
  * \param [in] type The name of the class
  *
  * This macro implements
  *
- *   - The \p typeValue class methods,
+ *   - The \pname{typeValue} class methods,
  *
  *   - The \c MaketypeChecker function,
  *
- * for class \p type.
+ * for class \pname{type}.
  *
  * This macro should be invoked from the class implementation file.
  */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/boolean.cc ns-3.31/src/core/model/boolean.cc
--- ns-3.30.1/src/core/model/boolean.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/boolean.cc	2020-06-27 17:38:30.000000000 -0700
@@ -71,14 +71,14 @@
   return os;
 }
 
-Ptr<AttributeValue> 
+Ptr<AttributeValue>
 BooleanValue::Copy (void) const
 {
   NS_LOG_FUNCTION (this);
 
   return Create<BooleanValue> (*this);
 }
-std::string 
+std::string
 BooleanValue::SerializeToString (Ptr<const AttributeChecker> checker) const
 {
   NS_LOG_FUNCTION (this << checker);
@@ -86,27 +86,27 @@
   if (m_value)
     {
       return "true";
-    } 
+    }
   else
     {
       return "false";
     }
 }
-bool 
+bool
 BooleanValue::DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker)
 {
   NS_LOG_FUNCTION (this << value << checker);
 
-  if (value == "true" ||
-      value == "1" ||
-      value == "t")
+  if (value == "true"
+      || value == "1"
+      || value == "t")
     {
       m_value = true;
       return true;
     }
-  else if (value == "false" ||
-           value == "0" ||
-           value == "f")
+  else if (value == "false"
+           || value == "0"
+           || value == "f")
     {
       m_value = false;
       return true;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/build-profile.h ns-3.31/src/core/model/build-profile.h
--- ns-3.30.1/src/core/model/build-profile.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/build-profile.h	2020-06-27 17:38:30.000000000 -0700
@@ -33,13 +33,11 @@
  * Build profile no-op macro.
  * \param [in] code The code to skip.
  */
-#define NS_BUILD_PROFILE_NOOP(code)             \
-  do                                            \
-      if (false)                                \
-        {                                       \
-          code ;                                \
-        }                                       \
-  while (false)
+#define NS_BUILD_PROFILE_NOOP(code)            \
+  do if (false)                                \
+    {                                          \
+      code;                                    \
+    } while (false)
 
 /**
  * \ingroup debugging
@@ -49,9 +47,8 @@
 #define NS_BUILD_PROFILE_OP(code) \
   do                                            \
     {                                           \
-      code ;                                    \
-    }                                           \
-  while (false)
+      code;                                     \
+    }  while (false)
 
 
 #ifdef NS3_BUILD_PROFILE_DEBUG
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/cairo-wideint.c ns-3.31/src/core/model/cairo-wideint.c
--- ns-3.30.1/src/core/model/cairo-wideint.c	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/cairo-wideint.c	2020-06-27 17:38:30.000000000 -0700
@@ -40,6 +40,8 @@
  * Implementation of the cairo_x functions which implement high precision arithmetic.
  */
 
+// *NS_CHECK_STYLE_OFF*
+
 #if HAVE_UINT64_T
 
 const char * cairo_impl64 = "uint64_t";
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/cairo-wideint-private.h ns-3.31/src/core/model/cairo-wideint-private.h
--- ns-3.30.1/src/core/model/cairo-wideint-private.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/cairo-wideint-private.h	2020-06-27 17:38:30.000000000 -0700
@@ -41,13 +41,15 @@
  */
 
 // Adapt to ns-3 environment
+// Additional changes from upstream are marked with `//PDB'
 #include "ns3/core-config.h"
-#define cairo_private 
+#define cairo_private
 #define HAVE_UINT64_T 1
 // Implementation tags added below and in cairo-wideint.c:
 // extern const char * cairo_impl64;
 // extern const char * cairo_impl128;
 
+// *NS_CHECK_STYLE_OFF*
 
 /*for compatibility with MacOS and Cygwin*/
 #ifndef HAVE_STDINT_H
@@ -99,7 +101,10 @@
  * as a pair of 32-bit ints
  */
 
-#define I cairo_private
+//PDB preprocessor symbol 'I' conflicts with
+// `#define I _Complex_I` in <complex>
+// Substitute a less generic symbol here
+#define cairo_I  cairo_private
 
 #if !HAVE_UINT64_T
 
@@ -109,31 +114,31 @@
   uint32_t    lo, hi;
 } cairo_uint64_t, cairo_int64_t;
 
-cairo_uint64_t I        _cairo_uint32_to_uint64 (uint32_t i);
+cairo_uint64_t cairo_I  _cairo_uint32_to_uint64 (uint32_t i);
 #define                 _cairo_uint64_to_uint32(a)  ((a).lo)
-cairo_uint64_t I        _cairo_uint64_add (cairo_uint64_t a, cairo_uint64_t b);
-cairo_uint64_t I        _cairo_uint64_sub (cairo_uint64_t a, cairo_uint64_t b);
-cairo_uint64_t I        _cairo_uint64_mul (cairo_uint64_t a, cairo_uint64_t b);
-cairo_uint64_t I        _cairo_uint32x32_64_mul (uint32_t a, uint32_t b);
-cairo_uint64_t I        _cairo_uint64_lsl (cairo_uint64_t a, int shift);
-cairo_uint64_t I        _cairo_uint64_rsl (cairo_uint64_t a, int shift);
-cairo_uint64_t I        _cairo_uint64_rsa (cairo_uint64_t a, int shift);
-int            I        _cairo_uint64_lt (cairo_uint64_t a, cairo_uint64_t b);
-int            I        _cairo_uint64_eq (cairo_uint64_t a, cairo_uint64_t b);
-cairo_uint64_t I        _cairo_uint64_negate (cairo_uint64_t a);
+cairo_uint64_t cairo_I  _cairo_uint64_add (cairo_uint64_t a, cairo_uint64_t b);
+cairo_uint64_t cairo_I  _cairo_uint64_sub (cairo_uint64_t a, cairo_uint64_t b);
+cairo_uint64_t cairo_I  _cairo_uint64_mul (cairo_uint64_t a, cairo_uint64_t b);
+cairo_uint64_t cairo_I  _cairo_uint32x32_64_mul (uint32_t a, uint32_t b);
+cairo_uint64_t cairo_I  _cairo_uint64_lsl (cairo_uint64_t a, int shift);
+cairo_uint64_t cairo_I  _cairo_uint64_rsl (cairo_uint64_t a, int shift);
+cairo_uint64_t cairo_I  _cairo_uint64_rsa (cairo_uint64_t a, int shift);
+int            cairo_I  _cairo_uint64_lt (cairo_uint64_t a, cairo_uint64_t b);
+int            cairo_I  _cairo_uint64_eq (cairo_uint64_t a, cairo_uint64_t b);
+cairo_uint64_t cairo_I  _cairo_uint64_negate (cairo_uint64_t a);
 #define                 _cairo_uint64_negative(a)   (((int32_t)((a).hi)) < 0)
-cairo_uint64_t I        _cairo_uint64_not (cairo_uint64_t a);
+cairo_uint64_t cairo_I  _cairo_uint64_not (cairo_uint64_t a);
 
 #define                 _cairo_uint64_to_int64(i)   (i)
 #define                 _cairo_int64_to_uint64(i)   (i)
 
-cairo_int64_t  I        _cairo_int32_to_int64 (int32_t i);
+cairo_int64_t  cairo_I  _cairo_int32_to_int64 (int32_t i);
 #define                 _cairo_int64_to_int32(a)    ((int32_t) _cairo_uint64_to_uint32 (a))
 #define                 _cairo_int64_add(a,b)       _cairo_uint64_add (a,b)
 #define                 _cairo_int64_sub(a,b)       _cairo_uint64_sub (a,b)
 #define                 _cairo_int64_mul(a,b)       _cairo_uint64_mul (a,b)
-cairo_int64_t  I        _cairo_int32x32_64_mul (int32_t a, int32_t b);
-int            I        _cairo_int64_lt (cairo_uint64_t a, cairo_uint64_t b);
+cairo_int64_t  cairo_I  _cairo_int32x32_64_mul (int32_t a, int32_t b);
+int            cairo_I  _cairo_int64_lt (cairo_uint64_t a, cairo_uint64_t b);
 #define                 _cairo_int64_eq(a,b)        _cairo_uint64_eq (a,b)
 #define                 _cairo_int64_lsl(a,b)       _cairo_uint64_lsl (a,b)
 #define                 _cairo_int64_rsl(a,b)       _cairo_uint64_rsl (a,b)
@@ -232,28 +237,28 @@
   cairo_uint64_t      lo, hi;
 } cairo_uint128_t, cairo_int128_t;
 
-cairo_uint128_t I       _cairo_uint32_to_uint128 (uint32_t i);
-cairo_uint128_t I       _cairo_uint64_to_uint128 (cairo_uint64_t i);
+cairo_uint128_t cairo_I _cairo_uint32_to_uint128 (uint32_t i);
+cairo_uint128_t cairo_I _cairo_uint64_to_uint128 (cairo_uint64_t i);
 #define                 _cairo_uint128_to_uint64(a)     ((a).lo)
 #define                 _cairo_uint128_to_uint32(a)     _cairo_uint64_to_uint32 (_cairo_uint128_to_uint64 (a))
-cairo_uint128_t I       _cairo_uint128_add (cairo_uint128_t a, cairo_uint128_t b);
-cairo_uint128_t I       _cairo_uint128_sub (cairo_uint128_t a, cairo_uint128_t b);
-cairo_uint128_t I       _cairo_uint128_mul (cairo_uint128_t a, cairo_uint128_t b);
-cairo_uint128_t I       _cairo_uint64x64_128_mul (cairo_uint64_t a, cairo_uint64_t b);
-cairo_uint128_t I       _cairo_uint128_lsl (cairo_uint128_t a, int shift);
-cairo_uint128_t I       _cairo_uint128_rsl (cairo_uint128_t a, int shift);
-cairo_uint128_t I       _cairo_uint128_rsa (cairo_uint128_t a, int shift);
-int             I       _cairo_uint128_lt (cairo_uint128_t a, cairo_uint128_t b);
-int             I       _cairo_uint128_eq (cairo_uint128_t a, cairo_uint128_t b);
-cairo_uint128_t I       _cairo_uint128_negate (cairo_uint128_t a);
+cairo_uint128_t cairo_I _cairo_uint128_add (cairo_uint128_t a, cairo_uint128_t b);
+cairo_uint128_t cairo_I _cairo_uint128_sub (cairo_uint128_t a, cairo_uint128_t b);
+cairo_uint128_t cairo_I _cairo_uint128_mul (cairo_uint128_t a, cairo_uint128_t b);
+cairo_uint128_t cairo_I _cairo_uint64x64_128_mul (cairo_uint64_t a, cairo_uint64_t b);
+cairo_uint128_t cairo_I _cairo_uint128_lsl (cairo_uint128_t a, int shift);
+cairo_uint128_t cairo_I _cairo_uint128_rsl (cairo_uint128_t a, int shift);
+cairo_uint128_t cairo_I _cairo_uint128_rsa (cairo_uint128_t a, int shift);
+int             cairo_I _cairo_uint128_lt (cairo_uint128_t a, cairo_uint128_t b);
+int             cairo_I _cairo_uint128_eq (cairo_uint128_t a, cairo_uint128_t b);
+cairo_uint128_t cairo_I _cairo_uint128_negate (cairo_uint128_t a);
 #define                 _cairo_uint128_negative(a)  (_cairo_uint64_negative (a.hi))
-cairo_uint128_t I       _cairo_uint128_not (cairo_uint128_t a);
+cairo_uint128_t cairo_I _cairo_uint128_not (cairo_uint128_t a);
 
 #define                 _cairo_uint128_to_int128(i)     (i)
 #define                 _cairo_int128_to_uint128(i)     (i)
 
-cairo_int128_t  I       _cairo_int32_to_int128 (int32_t i);
-cairo_int128_t  I       _cairo_int64_to_int128 (cairo_int64_t i);
+cairo_int128_t  cairo_I _cairo_int32_to_int128 (int32_t i);
+cairo_int128_t  cairo_I _cairo_int64_to_int128 (cairo_int64_t i);
 #define                 _cairo_int128_to_int64(a)   ((cairo_int64_t)(a).lo)
 #define                 _cairo_int128_to_int32(a)   _cairo_int64_to_int32 (_cairo_int128_to_int64 (a))
 #define                 _cairo_int128_add(a,b)      _cairo_uint128_add (a,b)
@@ -263,7 +268,7 @@
 #define                 _cairo_int128_lsl(a,b)      _cairo_uint128_lsl (a,b)
 #define                 _cairo_int128_rsl(a,b)      _cairo_uint128_rsl (a,b)
 #define                 _cairo_int128_rsa(a,b)      _cairo_uint128_rsa (a,b)
-int             I       _cairo_int128_lt (cairo_int128_t a, cairo_int128_t b);
+int             cairo_I _cairo_int128_lt (cairo_int128_t a, cairo_int128_t b);
 #define                 _cairo_int128_eq(a,b)       _cairo_uint128_eq (a,b)
 #define                 _cairo_int128_negate(a)     _cairo_uint128_negate (a)
 #define                 _cairo_int128_negative(a)   (_cairo_uint128_negative (a))
@@ -355,5 +360,6 @@
 };
 #endif
 
+// *NS_CHECK_STYLE_ON*
 
 #endif /* CAIRO_WIDEINT_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/calendar-scheduler.cc ns-3.31/src/core/model/calendar-scheduler.cc
--- ns-3.30.1/src/core/model/calendar-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/calendar-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -16,10 +16,13 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Author: Alexander Krotov <krotov@iitp.ru>
  */
 
 #include "calendar-scheduler.h"
 #include "event-impl.h"
+#include "type-id.h"
+#include "boolean.h"
 #include <utility>
 #include <string>
 #include <list>
@@ -45,6 +48,12 @@
     .SetParent<Scheduler> ()
     .SetGroupName ("Core")
     .AddConstructor<CalendarScheduler> ()
+    .AddAttribute ("Reverse",
+                   "Store events in reverse chronological order",
+                   TypeId::ATTR_CONSTRUCT,
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&CalendarScheduler::SetReverse),
+                   MakeBooleanChecker ())
   ;
   return tid;
 }
@@ -62,6 +71,43 @@
   m_buckets = 0;
 }
 void
+CalendarScheduler::SetReverse (bool reverse)
+{
+  NS_LOG_FUNCTION (this << reverse);
+  m_reverse = reverse;
+
+  if (m_reverse)
+    {
+      NextEvent = [] (Bucket & bucket) -> Scheduler::Event &
+        {
+          return bucket.back ();
+        };
+      Order = [](const EventKey & a, const EventKey & b) -> bool
+        {
+          return a > b;
+        };
+      Pop = [] (Bucket & bucket) -> void
+        {
+          bucket.pop_back ();
+        };
+    }
+  else
+    {
+      NextEvent = [](Bucket & bucket) -> Scheduler::Event &
+        {
+          return bucket.front ();
+        };
+      Order = [](const EventKey & a, const EventKey & b) -> bool
+        {
+          return a < b;
+        };
+      Pop = [] (Bucket & bucket) -> void
+        {
+          bucket.pop_front ();
+        };
+    }
+}
+void
 CalendarScheduler::Init (uint32_t nBuckets,
                          uint64_t width,
                          uint64_t startPrio)
@@ -108,7 +154,7 @@
   Bucket::iterator end = m_buckets[bucket].end ();
   for (Bucket::iterator i = m_buckets[bucket].begin (); i != end; ++i)
     {
-      if (ev.key < i->key)
+      if (Order (ev.key, i->key) )
         {
           m_buckets[bucket].insert (i, ev);
           return;
@@ -147,7 +193,7 @@
     {
       if (!m_buckets[i].empty ())
         {
-          Scheduler::Event next = m_buckets[i].front ();
+          Scheduler::Event next = NextEvent (m_buckets[i]);
           if (next.key.m_ts < bucketTop)
             {
               return next;
@@ -175,21 +221,21 @@
   uint64_t bucketTop = m_bucketTop;
   int32_t minBucket = -1;
   Scheduler::EventKey minKey;
-  NS_ASSERT(!IsEmpty());
-  minKey.m_ts = uint64_t(-int64_t(1));
+  NS_ASSERT (!IsEmpty ());
+  minKey.m_ts = uint64_t (-int64_t (1));
   minKey.m_uid = 0;
   minKey.m_context = 0xffffffff;
   do
     {
       if (!m_buckets[i].empty ())
         {
-          Scheduler::Event next = m_buckets[i].front ();
+          Scheduler::Event next = NextEvent (m_buckets[i]);
           if (next.key.m_ts < bucketTop)
             {
               m_lastBucket = i;
               m_lastPrio = next.key.m_ts;
               m_bucketTop = bucketTop;
-              m_buckets[i].pop_front ();
+              Pop (m_buckets[i]);
               return next;
             }
           if (next.key < minKey)
@@ -207,8 +253,8 @@
   m_lastPrio = minKey.m_ts;
   m_lastBucket = Hash (minKey.m_ts);
   m_bucketTop = (minKey.m_ts / m_width + 1) * m_width;
-  Scheduler::Event next = m_buckets[minBucket].front();
-  m_buckets[minBucket].pop_front ();
+  Scheduler::Event next = NextEvent (m_buckets[minBucket]);
+  Pop (m_buckets[minBucket]);
 
   return next;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/calendar-scheduler.h ns-3.31/src/core/model/calendar-scheduler.h
--- ns-3.30.1/src/core/model/calendar-scheduler.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/calendar-scheduler.h	2020-06-27 17:38:30.000000000 -0700
@@ -16,6 +16,7 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Author: Alexander Krotov <krotov@iitp.ru>
  */
 
 #ifndef CALENDAR_SCHEDULER_H
@@ -41,17 +42,52 @@
  *
  * This event scheduler is a direct implementation of the algorithm
  * known as a calendar queue, first published in 1988 in
- * "Calendar Queues: A Fast O(1) Priority Queue Implementation for
- * the Simulation Event Set Problem" by Randy Brown. There are many
+ * ["Calendar Queues: A Fast O(1) Priority Queue Implementation for
+ * the Simulation Event Set Problem" by Randy Brown][Brown]. There are many
  * refinements published later but this class implements
  * the original algorithm (to the best of my knowledge).
  *
+ * [Brown]: https://doi.org/10.1145/63039.63045 "Brown"
+ *
+ * This class uses a vector of buckets; each bucket covers a uniform
+ * time span.  The bucket index for an event with timestamp `ts` is
+ * `(ts / m_width) % m_nBuckets`.  This class automatically adjusts
+ * the number of buckets to keep the average occupancy around 2.
+ * Buckets themselves are implemented as a `std::list<>`, and events are
+ * kept sorted withing the buckets.
+ *
+ * \par Time Complexity
+ *
+ * Operation    | Amortized %Time | Reason
+ * :----------- | :-------------- | :-----
+ * Insert()     | ~Constant       | Ordering within bucket; possible resize
+ * IsEmpty()    | Constant        | Explicit queue size
+ * PeekNext()   | ~Constant       | Search buckets
+ * Remove()     | ~Constant       | Search within bucket; possible resize
+ * RemoveNext() | ~Constant       | Search buckets; possible resize
+ *
+ * \par Memory Complexity
+ *
+ * Category  | Memory                           | Reason
+ * :-------- | :------------------------------- | :-----
+ * Overhead  | 2 x `sizeof (*)` + `size_t`<br/>(24 bytes) | `std::list`
+ * Per Event | 2 x `sizeof (*)`                 | `std::list`
+ *
  * \note
  * This queue is much slower than I expected (much slower than the
  * std::map queue) and this seems to be because the original resizing policy
  * is horribly bad.  This is most likely the reason why there have been
  * so many variations published which all slightly tweak the resizing
  * heuristics to obtain a better distribution of events across buckets.
+ *
+ * \note While inserion sort is not discussed in the original article, its
+ * implementation appears to dramatically affect performance.
+ * The default implementation sorts buckets in increasing (chronological)
+ * order.  The alternative, sorting buckets in decreasing order,
+ * was adopted in NS-2 because they observed that new events were
+ * more likely to be later than already scheduled events.
+ * In this case sorting buckets in reverse chronological order
+ * reduces enqueue time.
  */
 class CalendarScheduler : public Scheduler
 {
@@ -132,7 +168,7 @@
 
   /** Calendar bucket type: a list of Events. */
   typedef std::list<Scheduler::Event> Bucket;
-  
+
   /** Array of buckets. */
   Bucket *m_buckets;
   /** Number of buckets in the array. */
@@ -147,6 +183,41 @@
   uint64_t m_lastPrio;
   /** Number of events in queue. */
   uint32_t m_qSize;
+
+  /**
+   * Set the insertion order.
+   *
+   * This can only be used at construction, as invoked by the
+   * Attribute Reverse.
+   *
+   * \param [in] reverse If \c true, store events in *decreasing*
+   * time stamp order.
+   */
+  void SetReverse (bool reverse);
+  /**
+   * Get the next event from the bucket, according to \c m_reverse.
+   * \param [in] bucket The bucket to draw from.
+   * \return The next event from the \c bucket.
+   */
+  Scheduler::Event & (*NextEvent) (Bucket & bucket);
+  /**
+   * Ordering function to identify the insertion point, according to \c m_reverse.
+   * \param [in] newEvent The new event being inserted.
+   * \param [in] it The current position in the bucket being examined.
+   * \return \c true if the \c newEvent belongs before \it.
+   */
+  bool (*Order) (const EventKey & newEvent, const EventKey & it);
+  /**
+   * Pop the next event from the bucket, according to \c m_reverse.
+   * \param [in] bucket The bucket to pop from.
+   */
+  void (*Pop) (Bucket &);
+  /**
+   * Bucket ordering.
+   * If \c false (default), store events in increasing time stamp order.
+   * If \c true, store events in *decreasing* time stamp order.
+   */
+  bool m_reverse = false;
 };
 
 } // namespace ns3
